﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.ApplicationModel.Resources;
using Windows.ApplicationModel.Resources.Core;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI;
using Windows.UI.ViewManagement;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Automation.Peers;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace HelloRealWorld
{
  public sealed partial class MainPage : Page
  {
    Brush defaultBackground;

    public MainPage()
    {
      InitializeComponent();

      // Save the default background for later
      this.defaultBackground = this.stackPanel.Background;

      AccessibilitySettings settings = new AccessibilitySettings();
      // Update the background whenever the theme changes
      settings.HighContrastChanged += OnHighContrastChanged;
      // Set the background appropriately on initialization
      OnHighContrastChanged(settings, null);
    }

    void OnHighContrastChanged(AccessibilitySettings sender, object args)
    {
      this.stackPanel.Background = sender.HighContrast ? null : this.defaultBackground;
    }

    void Button_Click(object sender, RoutedEventArgs e)
    {
      this.result.Text = this.nameBox.Text;
      // Notify a screen reader to report this text
      TextBlockAutomationPeer.FromElement(this.result).RaiseAutomationEvent(
        AutomationEvents.LiveRegionChanged);
    }
  }
}
