﻿using System;
using Windows.UI.Input;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Input;

namespace Chapter6
{
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            InitializeComponent();

            // Event for beginning drag
            shape.PointerPressed += Shape_PointerPressed;

            // Event for dragging
            shape.PointerMoved += Shape_PointerMoved;

            // All the events that should terminate the drag
            shape.PointerReleased += Shape_PointerReleased;
            shape.PointerCanceled += Shape_PointerReleased;
            shape.PointerCaptureLost += Shape_PointerReleased;
        }

        void Shape_PointerPressed(object sender, PointerRoutedEventArgs e)
        {
            shape.CapturePointer(e.Pointer);
        }

        void Shape_PointerMoved(object sender, PointerRoutedEventArgs e)
        {
            // Only move the shape if one pointer is currently pressed
            if (shape.PointerCaptures != null && shape.PointerCaptures.Count == 1)
            {
                PointerPoint point = e.GetCurrentPoint(null);

                // Center the shape under the pointer
                Canvas.SetLeft(shape, point.Position.X - (shape.ActualWidth / 2));
                Canvas.SetTop(shape, point.Position.Y - (shape.ActualHeight / 2));
            }
        }

        void Shape_PointerReleased(object sender, PointerRoutedEventArgs e)
        {
            shape.ReleasePointerCapture(e.Pointer);
        }
    }
}