﻿using System;
using Windows.UI.Core;
using Windows.UI.ViewManagement;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace MultipleWindows
{
  public sealed partial class MainPage : Page
  {
    public MainPage()
    {
      InitializeComponent();
    }

    async void Button_Click(object sender, RoutedEventArgs e)
    {
      int newWindowId = 0;

      // Create the new window with our handy helper method
      Window newWindow = await (App.Current as App).CreateWindowAsync();

      // Initialize the new window on its UI thread
      await newWindow.Dispatcher.RunAsync(CoreDispatcherPriority.Normal, () =>
      {
        // In this context, Window.Current is the new window.
        // Navigate its content to a different page.
        Frame frame = new Frame();
        frame.Navigate(typeof(SecondPage));
        Window.Current.Content = frame;

        // Set a different title
        ApplicationView.GetForCurrentView().Title = "NEW";

        newWindowId = ApplicationView.GetApplicationViewIdForWindow(newWindow.CoreWindow);
      });

      // Back on the original UI thread, show the new window alongside this one
      bool success = await ApplicationViewSwitcher.TryShowAsStandaloneAsync(newWindowId);
    }
  }
}