﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Threading.Tasks;
using Windows.ApplicationModel.Store;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Core;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

using CurrentApp = Windows.ApplicationModel.Store.CurrentAppSimulator;

namespace Chapter9
{
  /// <summary>
  /// An empty page that can be used on its own or navigated to within a Frame.
  /// </summary>
  public sealed partial class MainPage : Page
  {
    public MainPage()
    {
      this.InitializeComponent();

      BuyVirtualCoins();
    }

    async Task BuyVirtualCoins()
    {
      try
      {
        string ss = await CurrentApp.GetAppReceiptAsync();

        string productId = "2";      // The ID of the product in the dashboard
        string offerId = "Spring Theme Pack"; // The ID of the logical product, which only has meaning to you

        FulfillmentResult r = await CurrentApp.ReportConsumableFulfillmentAsync(productId, Guid.Empty);

        // Show the standard purchase dialog
        PurchaseResults results = await CurrentApp.RequestProductPurchaseAsync(productId, offerId, new ProductPurchaseDisplayProperties
        {
          Name = "Spring Theme Pack",
          Description = "A colorful theme for this app."
        });
        if (results.Status == ProductPurchaseStatus.Succeeded)
        {

        }
      }
      catch
      {
        // There was an error (such as no network connection).
        // Make sure there isn't an unfulfilled purchase.
      }
    }
  }
}
