﻿using System;
using Windows.Foundation;
using Windows.UI;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Media;
using DirectXSamples; // namespace used by C++ component

namespace Chapter26
{
  public sealed partial class MainPage : Page
  {
    SampleD2DImageSource imageSource1;
    SampleD3DImageSource imageSource2;
    Random random = new Random();

    public MainPage()
    {
      InitializeComponent();

      this.imageSource1 = new SampleD2DImageSource((int)this.image1.Width, (int)this.image1.Height, true);
      this.imageSource2 = new SampleD3DImageSource((int)this.image2.Width, (int)this.image2.Height, true);

      this.image1.Source = this.imageSource1;
      this.textBlock1.Foreground = new ImageBrush() { ImageSource = this.imageSource1, Stretch = Stretch.UniformToFill };

      this.image2.Source = this.imageSource2;
      this.textBlock2.Foreground = new ImageBrush() { ImageSource = this.imageSource2, Stretch = Stretch.UniformToFill };

      CompositionTarget.Rendering += CompositionTarget_Rendering;
    }

    // Update the ImageSource on each frame
    void CompositionTarget_Rendering(object sender, object args)
    {
      this.imageSource2.BeginDraw();
      this.imageSource2.Clear(Colors.Orange);
      this.imageSource2.RenderNextAnimationFrame();
      this.imageSource2.EndDraw();


      this.imageSource1.BeginDraw();
      this.imageSource1.Clear(Colors.Orange);

      // Draw 100 random squares
      const int SIZE = 20;
      byte[] rgb = new byte[3];
      for (int i = 0; i < 100; i++)
      {
        Rect bounds = new Rect(this.random.Next((int)this.image1.Width - SIZE), this.random.Next((int)this.image1.Height - SIZE), SIZE, SIZE);
        this.random.NextBytes(rgb);
        imageSource1.FillSolidRect(new Color() { A = 255, R = rgb[0], G = rgb[1], B = rgb[2] }, bounds);
      }

      this.imageSource1.EndDraw();
    }
  }
}